﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace CameraDemo
{
    public partial class Form1 : Form
    {
        bool isCaptured = false;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            Camera.PowerOn();
            Camera.StartPreview(panel2.Bounds.X + 1, panel2.Bounds.Y + 1, 135, 180);

        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {

            Camera.StopPreview();
            Camera.PowerOff();
        }

        private void checkBox1_CheckStateChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                Camera.FlashOn();
            }
            else
            {
                Camera.FlashOff();
            }
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

            if (e.KeyData == Keys.F23)
            {
                if (isCaptured)
                {
                    return;
                }

                if (Camera.IsAFMode())
                {
                    Camera.AutoFocus();
                }
                else
                {
                    Capture();
                }
            }
            else if (e.KeyData == Keys.Escape)
            {
                this.Close();
            }
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            if (isCaptured)
            {
                return;
            }

            if (e.KeyData == Keys.F23)
            {
                if (Camera.IsAFMode())
                {
                    Capture();
                }
                        
            }
        }

        private void Capture()
        {
            IntPtr hbmp = Camera.Capture(1);
            if (hbmp != IntPtr.Zero)
            {
                Image img = Image.FromHbitmap(hbmp);

                Camera.FlashOff();
                Camera.StopPreview();

                checkBox1.Checked = false;
                this.pictureBox1.Image = img;
                img.Save("\\cameredemo.jpg", ImageFormat.Jpeg);


                Camera.CloseHandle(hbmp);
            }

            isCaptured = true;
        }
    }
}