﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace TestCamera
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //1、 -prefix，字符串, 指定保存的照片名的前缀， 前缀如果有空格需要用引号引住，默认为"image"。
            //2、 -location, 字符串，指定照片保存的目录， 路径如果有空格需要用引号引住，默认为程序当前目录。
            //3、 -limit, 整数，指定最多可拍照片张数，0为无限制，默认为0。
            //4、 -flash 整数，0为关闪光灯，1为开闪光灯，默认为0。
            //5、 -format 字符串, “bmp”保存为BMP格式，"jpg"保存为JPG格式，默认为"jpg"
            //6、 -limittip 整数，0为达到拍照限制数无提示，1为拍照限制数提示，默认为0。
            //7、 -exitconfirm 整数，0为退出无提示，1为退出提示，默认为1。
            //8、 -size 整数，设置拍照尺寸 1为 640x480,2为800x600，3为1024x768，默认为1。
            //9、 -autosave 整数，1为自动保存，0为不保存，默认为0
            //10、 -viewtimeout 整数，指定拍照后照片回显秒数，-1为无穷大，0为不回显， 默认为5。

            StringBuilder sb = new StringBuilder();

            if (textBox1.Text.Length > 0)
	        {
                sb.AppendFormat(" -location \"{0}\"", textBox1.Text);
	        }

            if (textBox2.Text.Length > 0)
	        {
                sb.AppendFormat(" -prefix \"{0}\"", textBox2.Text);
            }

            if (textBox3.Text != "0")
            {
                sb.AppendFormat(" -limit {0}", textBox3.Text);
            }

            if (comboBox1.SelectedIndex != 0)
            {
                sb.AppendFormat(" -size {0}", comboBox1.SelectedIndex + 1);
            }

            if (comboBox2.SelectedIndex != 0)
            {
                sb.Append(" -format bmp");
            }
            else if (textBox5.Text != "90")
            {
                sb.Append(" -format jpg" + textBox5.Text);
            }

            if (checkBox2.Checked)
            {
                sb.Append(" -flash 1");
            }

            if (checkBox1.Checked)
            {
                sb.Append(" -limittip 1");
            }
    
            if (!checkBox3.Checked)
            {
                sb.Append(" -exitconfirm 0");                
            }

            if (textBox4.Text != "5")
            {
                sb.AppendFormat(" -viewtimeout {0}", textBox4.Text);
            }

            if (checkBox4.Checked)
            {
                sb.Append(" -autosave 1");
            }

            
            Process camera = new Process();
            camera.StartInfo.FileName = "\\windows\\Camera.exe";
            camera.StartInfo.Arguments = sb.ToString();
            camera.StartInfo.UseShellExecute = false;            
            camera.Start();
            camera.WaitForExit();
            camera.Close();

        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox2.SelectedIndex == 0)
            {
                textBox5.Enabled = true;
            }
            else
            {
                textBox5.Enabled = false;
            }
        }

    }
}