﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using LC;
using System.Runtime.InteropServices;

namespace ScanDemo
{   
    public partial class Form1 : Form
    {

        Scanner scanner = new Scanner();

        /// <summary>
        /// 自动扫描关闭激光计数器,10秒没有扫描到条码则关闭自动扫描
        /// </summary>
        private int scanCount = 0;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
 
            this.KeyPreview = true;
            this.timer1.Interval = 1000;

            scanner.DecodeEvent += new EventHandler<DecodeEventArgs>(scanner_DecodeEvent);
            scanner.Start();

        }

        void scanner_DecodeEvent(object sender, DecodeEventArgs e)
        {
            Win32.sndPlaySound(Properties.Resources.Scan, Win32.SND_ASYNC | Win32.SND_MEMORY);

            this.BeginInvoke((Action<string>)delegate(string barcode)
            {
                scanCount = 0;
                ListViewItem item = new ListViewItem(new string[] { barcode });
                lstView.Items.Insert(0, item);

            }, e.Barcode);
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            scanner.Stop();
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            //10秒没扫到东西则关闭扫描头
            if (scanner.IsContinuousMode && (++scanCount >= 10))
            {
                if (scanner.SwitchTriggerMode())
                {
                    scanCount = 0;
                    btnSwitch.Text = "Auto Mode";
                    timer1.Enabled = false;
                }
            }
        }
             
      
        private void btnSwitch_Click(object sender, EventArgs e)
        {
            if (scanner.SwitchTriggerMode())
            {
                if (scanner.IsContinuousMode)
                {
                    btnSwitch.Text = "Normal Mode";
                    timer1.Enabled = true;
                }
                else
                {

                    btnSwitch.Text = "Auto Mode";
                    timer1.Enabled = false;
                }

            }
        }
    }
}