﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Microsoft.WindowsCE.Forms;
using LC;

namespace TestSms
{
    
    public partial class Form1 : Form
    {
        SmsMgr smsMgr = new SmsMgr();


        public Form1()
        {
            InitializeComponent();
            smsMgr.SmsReceived += new EventHandler<SmsReceivedEventArgs>(smsMgr_SmsReceived);
            smsMgr.SmsSent += new EventHandler<SmsSendResultEventArgs>(smsMgr_SmsSent);
        }
        
        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            if (smsMgr.IsOpened)
            {
                smsMgr.Close();
            }
        }


        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            button2.Enabled = true;

            if (Device.GetGsmPowerStatus() == 0)
            {
                Device.EnableGsmModule();
            }

            if (!smsMgr.IsOpened)
            {
                bool result = smsMgr.Open();
                if (!result)
                {
                    MessageBox.Show("start failed");
                    button1.Enabled = true;
                    button2.Enabled = false;
                }
            }
            
        }


        private void button2_Click(object sender, EventArgs e)
        {
            button1.Enabled = true;
            button2.Enabled = false;
            if (smsMgr.IsOpened)
            {
                smsMgr.Close();
            }
        }


        private void button3_Click(object sender, EventArgs e)
        {
            MessageBox.Show("开始发送");            
            smsMgr.SendSMS(textBox2.Text, textBox1.Text);
        }


        void smsMgr_SmsSent(object sender, SmsSendResultEventArgs e)
        {
            MessageBox.Show(e.Result ? "send succ" : "send failed");
        }


        void smsMgr_SmsReceived(object sender, SmsReceivedEventArgs e)
        {
            StringBuilder sbPhoneNum = new StringBuilder(20);
            StringBuilder sbMsg = new StringBuilder(160);
            StringBuilder sbTime = new StringBuilder(20);

            ushort wid = 0;
            byte totalNum = 0;
            byte curNum = 0;
            if (smsMgr.ReadSMS(e.Index, sbPhoneNum, 20, sbMsg, 70, sbTime, 20, ref wid, ref totalNum, ref curNum))
            {
                smsMgr.DeleteSMS(e.Index);

                //如果totalnum > 1,则表示当前信息是一个长短信的一部分，此时wid表示长短信的id， curnum表示当前是第几部分，开发人员可以根据这些信息进行拼接。
               
                this.BeginInvoke((Action<Sms>)delegate(Sms sms)
                {
                    listView1.Items.Add(new ListViewItem(new string[] { sms.PhoneNum, sms.Content, sms.Time }));


                }, new Sms(sbPhoneNum.ToString(), sbMsg.ToString(), sbTime.ToString()));

            }
        }

    }


}