﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LC;
using System.Threading;

namespace BthDemo
{
    public partial class Form2 : Form
    {
        Bluetooth bth;
        List<DeviceInfo> deviceList;
        bool discovering = false;

        public Form2(Bluetooth bth, List<DeviceInfo> deviceList)
        {
            this.bth = bth;
            this.deviceList = deviceList;
            this.bth.InquiryResult += new EventHandler<InquiryResultEventArgs>(bth_InquiryResult);
            InitializeComponent();

            foreach (DeviceInfo info in deviceList)
            {
                listView1.Items.Add(new ListViewItem(new string[] { info.Name, info.Address}));
            }
        }

     
        private void Form2_Closing(object sender, CancelEventArgs e)
        {
            if (discovering)
            {
                e.Cancel = true;
                return;
            }
            this.bth.InquiryResult -= new EventHandler<InquiryResultEventArgs>(bth_InquiryResult);
        }  
     
        private void btnSearch_Click(object sender, EventArgs e)
        {
            btnSearch.Enabled = false;
            deviceList.Clear();
            listView1.Items.Clear();
            

            Thread t = new Thread((ThreadStart)delegate()
                {
                    discovering = true;
                    bth.DiscoverDevice();
                    discovering = false;

                    this.Invoke((Action<bool>)delegate(bool bEnabled)
                    {
                        btnSearch.Enabled = bEnabled;
                    }, true);


                });
            t.Start();
        }

        void bth_InquiryResult(object sender, InquiryResultEventArgs e)
        {
            this.Invoke((Action<DeviceInfo>)delegate(DeviceInfo info)
            {
                foreach (DeviceInfo inf in deviceList)
                {
                    if (inf.Address == info.Address)
                    {
                        deviceList.Remove(inf);
                        break;
                    }
                }
                deviceList.Add(info);


                foreach (ListViewItem item in listView1.Items)
                {
                    if (item.SubItems[1].Text == info.Address)
                    {
                        item.Text = info.Name;
                        return;
                    }
                }

                listView1.Items.Add(new ListViewItem(new string[] { info.Name, info.Address }));

            }, e.Info);
        }

     
    }
}