﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using System.Windows.Forms;
using Microsoft.Win32;

namespace LC
{
    public class Helper
    {
        private static NLog.Logger logger = NLog.LogManager.GetLogger("[Helper]");


        #region 将字符串转化为字节数组
        /// <summary>
        /// 将字符串转化为字节数组
        /// </summary>
        public static byte[] Hex2Byte(string strHex)
        {
            byte[] bytes = null;
            try
            {
                char[] charHex = strHex.ToUpper().ToCharArray();
                int bytesLength = charHex.Length / 2;
                bytes = new byte[bytesLength];
                if (bytesLength <= 0)
                {
                    return bytes;
                }

                int[] tempBytes = new int[2];

                //循环每次处理两个字符
                for (int i = 0; i < charHex.Length; i = i + 2)
                {
                    tempBytes[0] = HexChar2Int(charHex[i]) << 4 & 0XF0;
                    tempBytes[1] = HexChar2Int(charHex[i + 1]);
                    bytes[i / 2] = (byte)(tempBytes[0] + tempBytes[1]);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return bytes;
        }
        #endregion

        #region 将16进制字符转换为整型
        /// <summary>
        /// 将16进制字符转换为整型
        /// </summary>
        private static int HexChar2Int(char hexChar)
        {
            switch (hexChar)
            {
                case '0':
                    return 0;
                case '1':
                    return 1;
                case '2':
                    return 2;
                case '3':
                    return 3;
                case '4':
                    return 4;
                case '5':
                    return 5;
                case '6':
                    return 6;
                case '7':
                    return 7;
                case '8':
                    return 8;
                case '9':
                    return 9;
                case 'A':
                    return 10;
                case 'B':
                    return 11;
                case 'C':
                    return 12;
                case 'D':
                    return 13;
                case 'E':
                    return 14;
                case 'F':
                    return 15;
                default:
                    return 0;
            }
        }
        #endregion

        #region 获取当前时间戳
        public static string GetTimeStamp(DateTime dt)
        {
            return ((dt.Ticks - DateTime.Parse("1970-01-01 00:00:00").Ticks) / 10000000).ToString();
        }
        #endregion

        #region 设置系统时间
        /// <summary>
        /// 设置系统时间
        /// </summary>
        /// <param name="nowTime">时间</param>
        public static void SetSystemTime(DateTime nowTime)
        {
            Win32.SYSTEMTIME lpSysDate = new Win32.SYSTEMTIME(nowTime);
            Win32.SetLocalTime(lpSysDate);
        }
        #endregion
    }
}
